int resolutionWidth = 800;
int resolutionHeight = 550;

PImage imgMain, imgRiver, imgBoat, imgSheep, imgWolf, imgHay, imgWolfFlip, imgSheepFlip, imgHayFlip;
PImage imgButton, imgButtonPressed, imgButtonSmall, imgButtonSmallPressed, imgUpArrow, imgDownArrow;
PImage imgHayIN, imgHayOUT, imgSheepIN, imgSheepOUT, imgWolfIN, imgWolfOUT, imgBoatGO, imgBoatRETURN;
PImage imgCommand, imgButtonPlay, imgButtonClear, imgWin, imgButtonClearCommand, imgButtonClearCommandPressed;
PImage imgEmptyBoatError, imgFullBoatError, imgDifferentBoatError, imgSideBoatError, imgSheepEatHayError, imgWolfEatSheepError;
int boatX, boatY, hayX, hayY, sheepX, sheepY, wolfX, wolfY;
int pressed, currentPosition, currentCommandPosition, runCommand;
int[] command = new int[40];
int i, j, mode, boatSide, boatCargo, error, sheepSide, haySide, wolfSide; 
boolean sheepFlip, wolfFlip, hayFlip;
float commandTimer;
int highlightCommand;



void setup() {
	
	size(resolutionWidth,resolutionHeight);	
	frameRate(60);         
	smooth(); 
	
	imgMain = loadImage("images/main.jpg");
	imgRiver = loadImage("images/river.png");
	imgBoat = loadImage("images/boat.png");
	imgWolf = loadImage("images/wolf.png");
	imgHay = loadImage("images/hay.png");
	imgSheep = loadImage("images/sheep.png");
	imgButton = loadImage("images/button.png");
	imgButtonPressed = loadImage("images/buttonPressed.png");
	imgHayIN = loadImage("images/hayIN.png");
	imgHayOUT = loadImage("images/hayOUT.png");
	imgSheepIN = loadImage("images/sheepIN.png");
	imgSheepOUT = loadImage("images/sheepOUT.png");
	imgWolfIN = loadImage("images/wolfIN.png");
	imgWolfOUT = loadImage("images/wolfOUT.png");
	imgBoatGO = loadImage("images/boatGO.png");
	imgBoatRETURN = loadImage("images/boatRETURN.png");
	imgButtonSmall = loadImage("images/button_small.png");
	imgButtonSmallPressed = loadImage("images/button_smallPressed.png");
	imgUpArrow = loadImage("images/upArrow.png");
	imgDownArrow = loadImage("images/downArrow.png");
	imgButtonPlay = loadImage("images/play.png");
	imgButtonClear = loadImage("images/clear.png");
	imgHayFlip = loadImage("images/hayFlip.png");
	imgWolfFlip = loadImage("images/wolfFlip.png");
	imgSheepFlip = loadImage("images/sheepFlip.png");
	imgEmptyBoatError = loadImage("images/emptyBoatError.png");
	imgFullBoatError = loadImage("images/fullBoatError.png");
	imgDifferentBoatError = loadImage("images/differentBoatError.png");
	imgSideBoatError = loadImage("images/sideBoatError.png");
	imgSheepEatHayError = loadImage("images/sheepEatHayError.png");
	imgWolfEatSheepError = loadImage("images/wolfEatSheepError.png");
	imgWin = loadImage("images/win.png");
	imgButtonClearCommand = loadImage("images/buttonClearCommand.png");
	imgButtonClearCommandPressed = loadImage("images/buttonClearCommandPressed.png");

	
	
	boatX = 455;	
	//boatY = 410;
	boatY = 340;
	sheepX = 740;
	sheepY = 388;
	hayX = 685;
	hayY = 400;
	wolfX = 603;
	wolfY = 375;
	pressed = 0;
	currentPosition = 0;
	currentCommandPosition = 0;
	mode = 0;	// 0 = code, 1 = run, 2 = error
	runCommand = 0;
	hayFlip = false;
	wolfFlip = false;
	sheepFlip = false;		
	boatSide = 2;	// 0 = travel, 1 = left, 2 = right
	boatCargo = 0;	// 0 = empty, 1 = hay, 2 = sheep, 3 = wolf
	error = 0;
	commandTimer = 0;
	sheepSide = 2;		// 1 = left, 2 = right, 3 = on boat
	wolfSide = 2;
	haySide = 2;
	
	for(i=0;i<30;i++) command[i] = 0;
	
}



void resetPositions() {
	
	boatX = 455;		
	sheepX = 740;
	sheepY = 388;
	hayX = 685;
	hayY = 400;
	wolfX = 603;
	wolfY = 375;
	hayFlip = false;
	wolfFlip = false;
	sheepFlip = false;
	boatSide = 2;	// 0 = travel, 1 = left, 2 = right
	boatCargo = 0;	// 0 = empty, 1 = hay, 2 = sheep, 3 = wolf	
	commandTimer = 0;
	runCommand = 0;
	currentPosition = 0;
	sheepSide = 2;
	wolfSide = 2;
	haySide = 2;
	error = 0;		
	highlightCommand = 0;
}



void executeCommand() {
	
	highlightCommand = runCommand;
	
			switch( command[runCommand] ) {
					
					case 1:
						if(boatCargo == 0 && boatSide == haySide) {
							if(boatSide == 2) {
								hayX = 520 ;
								hayY = 380;
								hayFlip = false;						
							}
							if(boatSide == 1) {
								hayX = 520 - 245;
								hayY = 380;
								hayFlip = true;
							}
							boatCargo = 1;
							haySide = 3;
						}
						else {
							if(boatCargo !=0) error = 1;
							if(boatSide != haySide) error = 4;
						}
					break;
					
					case 2:
						if(boatCargo == 1) {
							if(boatSide == 2) {
								hayX = 685;
								hayY = 400;		
								hayFlip = false;				
							}
							if(boatSide == 1) {
								hayX = 663 - 593;
								hayY = 380 + 15;
								hayFlip = true;							
							}
							boatCargo = 0;	
							haySide = boatSide;					
						}
						else {
							if(boatCargo == 0) 
								error = 2;
							else
								error = 3;
						}					
					break;	
								
					case 3:
						if(boatCargo == 0 && boatSide == sheepSide) {
							if(boatSide == 2) {
								sheepX = 510;
								sheepY = 368;
								sheepFlip = false;
							}
							if(boatSide == 1) {
								sheepX = 510 - 245;
								sheepY = 368;
								sheepFlip = true;
							}
							boatCargo = 2;	
							sheepSide = 3;													
						}
						else {
							if(boatCargo !=0) error = 1;	
							if(boatSide != sheepSide) error = 4;					
						}
					break;
					
					case 4:
						if(boatCargo == 2) {
							if(boatSide == 2) {
								sheepX = 740;	
								sheepY = 388;
								sheepFlip = false;
							}
							if(boatSide == 1) {
								sheepX = 608 - 593;
								sheepY = 368 + 15;
								sheepFlip = true;	
							}			
							boatCargo = 0;
							sheepSide = boatSide;												
						}
						else {
							if(boatCargo == 0) 
								error = 2;
							else
								error = 3;
						}					
						
					break;			
						
					case 5:
						if(boatCargo == 0 && boatSide == wolfSide) {
							if(boatSide == 2) {
								wolfX = 510;
								wolfY = 360;
								wolfFlip = false;
							}
							if(boatSide == 1) {
								wolfX = 510 - 245;
								wolfY = 360;
								wolfFlip = true;
							}
							boatCargo = 3;
							wolfSide = 3;
						}	
						else {
							if(boatCargo !=0) error = 1;	
							if(boatSide != wolfSide) error = 4;					
						}									
					break;
					
					case 6:
						if(boatCargo == 3) {
							if(boatSide == 2) {
								wolfX = 603;
								wolfY = 375;
								wolfFlip = false;
							}
							if(boatSide == 1) {
								wolfX = 715 - 593;
								wolfY = 360 + 15;						
								wolfFlip = true;
							}			
							boatCargo = 0;
							wolfSide = boatSide;			
						}
						else {
							if(boatCargo == 0) 
								error = 2;
							else
								error = 3;
						}					
	
					break;	
					
					case 7:					
						boatSide = 1;
						boatX = 210;
							switch(boatCargo) {
								case 1:
									hayX = 520 - 245;
									hayY = 380;								
								break;
								case 2:
									sheepX = 510 - 245;
									sheepY = 368;								
								break;
								case 3:
									wolfX = 510 - 245;
									wolfY = 360;								
								break;
							}						
					break;
					
					case 8:					
						boatSide = 2;
						boatX = 455;
							switch(boatCargo) {
								case 1:								
									hayX = 520 ;
									hayY = 380;										
								break;
								case 2:
									sheepX = 510;
									sheepY = 368;
								break;
								case 3:
									wolfX = 510;
									wolfY = 360;															
								break;
							}		
					break;
					
				} // switch
				
				
				if(wolfSide == sheepSide && boatSide != sheepSide) {
					error = 5;
				}
				
				if (sheepSide == haySide && boatSide != sheepSide) {
					error = 6;
				}
					
				if(sheepSide == 1 && haySide == 1 && wolfSide == 1 && boatSide == 1) {		
					error = 7;
				}	
				
				
			runCommand++;
			if(runCommand > 7) currentPosition++;
			if(command[runCommand] == 0) {
				mode = 0;
			}
				
}



void draw() {
		
	background(255);			
	image(imgMain, 0, 0);	
	image(imgBoat, boatX, boatY);
	tint(255,128);
	image(imgRiver, 206, 433);
	noTint();
		
	if(sheepFlip)
		image(imgSheepFlip, sheepX, sheepY);
	else
		image(imgSheep, sheepX, sheepY);
		
	if(hayFlip)		
		image(imgHayFlip, hayX, hayY);
	else
		image(imgHay, hayX, hayY);
		
	if(wolfFlip) 		
		image(imgWolfFlip, wolfX, wolfY);
	else	
		image(imgWolf, wolfX, wolfY);
		
	image(imgButton, 520, 20);
	image(imgButton, 650, 20);
	image(imgButton, 520, 70);
	image(imgButton, 650, 70);
	image(imgButton, 520, 120);
	image(imgButton, 650, 120);
	image(imgButton, 520, 170);
	image(imgButton, 650, 170);
	image(imgButton, 520, 220);
	image(imgButton, 650, 220);	
	image(imgButtonSmall, 50, 275);
	image(imgButtonSmall, 130, 275);
	
	
	
	for(i = 0; i < 7; i++) {
			image(imgButtonClearCommand, 210, 26 + i * 35);
	}
	 
	
	
	if(pressed != 0) {
		switch (pressed) {
				case 1:
					image(imgButtonPressed, 520, 20);
				break;
				case 2:
					image(imgButtonPressed, 650, 20);
				break;
				case 3:
					image(imgButtonPressed, 520, 70);
				break;
				case 4:
					image(imgButtonPressed, 650, 70);
				break;
				case 5:
					image(imgButtonPressed, 520, 120);
				break;
				case 6:
					image(imgButtonPressed, 650, 120);
				break;
				case 7:
					image(imgButtonPressed, 520, 170);
				break;
				case 8:
					image(imgButtonPressed, 650, 170);
				break;
				case 9:
					image(imgButtonSmallPressed, 50, 275);
				break;
				case 10:
					image(imgButtonSmallPressed, 130, 275);
				break;
				case 11:
					image(imgButtonPressed, 520, 220);
				break;
				case 12:
					image(imgButtonPressed, 650, 220);
				break;
		}
		if(pressed >= 20) {
				image(imgButtonClearCommandPressed, 210, 26 + (pressed - 20) * 35);
		}
	}
	
	image(imgHayIN,530,27);
	image(imgHayOUT,660,27);
	image(imgSheepIN,530,77);
	image(imgSheepOUT,660,77);
	image(imgWolfIN,530,127);
	image(imgWolfOUT,660,127);
	image(imgBoatGO,530,177);
	image(imgBoatRETURN,660,177);
	image(imgUpArrow, 79, 278);
	image(imgDownArrow, 157, 278);
	image(imgButtonPlay, 564, 225);
	image(imgButtonClear, 694, 221);
			
	
	if( mode == 1) {		
		if(millis() - commandTimer > 1000) {
			commandTimer = millis();				
			executeCommand();
		}				
	}
		
			if(error != 0) {	
					switch (error) {
						case 1:
							image(imgFullBoatError, 0, 0);
						break;
						case 2:
							image(imgEmptyBoatError, 0, 0);
						break;
						case 3:
							image(imgDifferentBoatError, 0, 0);
						break;
						case 4:
							image(imgSideBoatError, 0, 0);
						break;
						case 5:
							image(imgWolfEatSheepError, 0, 0);
						break;
						case 6:
							image(imgSheepEatHayError, 0, 0);
						break;
						case 7:
							image(imgWin, 0, 0);
						break;
					}
					mode = 0;										
			}	
	
	
	
	
	
	
	
	fill(255,255,255,200);
	rect(50,20,150,245);
	if(mode == 1 || error != 0) {
		if(error != 0 && error!= 7)
			fill(255, 0, 0, 100);
		else
			fill(0, 255, 0, 100);
			
		if(highlightCommand < 6)
			rect(50, 20 + highlightCommand * 35, 150, 35);
		else
			rect(50, 20 + 6 * 35, 150, 35);
	}
	strokeWeight(2);
	line(80, 20, 80, 265);	
	for(i = 1;i < 7; i++) {
			line(50, 20 + i*35, 200, 20 + i*35);
	}
	
	
	for(i = currentPosition, j = 0; i < currentPosition + 7; i++,j++) {
		
			switch(command[i]) {
				case 1 :
					imgCommand = imgHayIN;
				break;
				case 2 :
					imgCommand = imgHayOUT;
				break;
				case 3 :
					imgCommand = imgSheepIN;
				break;
				case 4 :
					imgCommand = imgSheepOUT;
				break;
				case 5 :
					imgCommand = imgWolfIN;
				break;
				case 6 :
					imgCommand = imgWolfOUT;
				break;
				case 7 :
					imgCommand = imgBoatGO;
				break;
				case 8 :
					imgCommand = imgBoatRETURN;
				break;
				default :
					imgCommand = null;	
			}
			
			fill(0,0,0);
			if(i + 1 < 10)
				text(i + 1, 62, 43 + j * 35);
			else
				text(i + 1, 59, 43 + j * 35);
				
			if(command[i] != 0) image(imgCommand, 88, 25 + j * 35);		
	}
	
}


void deleteCommand( int com ) {
	
	
	for(i = currentPosition + com; i < currentCommandPosition; i++) {
		command[ i ] = command[ i + 1 ];
	}	 
			
	command[ currentCommandPosition ] = 0;
	currentCommandPosition--;	
		
}


void addCommand( int com ) {
	
	if(currentCommandPosition < 30) {
		command[currentCommandPosition] = com;
		currentCommandPosition++;
	}	
			
	if(currentCommandPosition > currentPosition + 7) currentPosition = currentCommandPosition - 7;
	if(currentPosition > currentCommandPosition) currentPosition = currentCommandPosition - 1;
}


void mousePressed() {
	
	if( error != 0 && mode == 0) error = 0;
	
	if(mouseX > 520 && mouseX < 640 && mouseY > 20 && mouseY < 62 && mode == 0) {
		pressed = 1;
		addCommand(1);
	}
	if(mouseX > 650 && mouseX < 770 && mouseY > 20 && mouseY < 62 && mode == 0) {
		pressed = 2;
		addCommand(2);
	}
	if(mouseX > 520 && mouseX < 640 && mouseY > 70 && mouseY < 112 && mode == 0) {
		pressed = 3;
		addCommand(3);
	}
	if(mouseX > 650 && mouseX < 770 && mouseY > 70 && mouseY < 112 && mode == 0) {
		pressed = 4;
		addCommand(4);
	}
	if(mouseX > 520 && mouseX < 640 && mouseY > 120 && mouseY < 162 && mode == 0) {
		pressed = 5;
		addCommand(5);
	}
	if(mouseX > 650 && mouseX < 770 && mouseY > 120 && mouseY < 162 && mode == 0) {
		pressed = 6;
		addCommand(6);
	}
	if(mouseX > 520 && mouseX < 640 && mouseY > 170 && mouseY < 212 && mode == 0) {
		pressed = 7;
		addCommand(7);
	}
	if(mouseX > 650 && mouseX < 770 && mouseY > 170 && mouseY < 212 && mode == 0) {
		pressed = 8;
		addCommand(8);
	}
	if(mouseX > 50 && mouseX < 120 && mouseY > 275 && mouseY < 300 && mode == 0) {
		pressed = 9;		
		if(currentPosition > 0) currentPosition--;			
	}
	if(mouseX > 130 && mouseX < 200 && mouseY > 275 && mouseY < 300 && mode == 0) {
		pressed = 10;
		if(currentPosition < 23) currentPosition++;		
	}
	if(mouseX > 520 && mouseX < 640 && mouseY > 220 && mouseY < 262) {
		pressed = 11;		
		
		if( mode == 0 && command[0] != 0) {			
			resetPositions();			
			mode = 1;						
			commandTimer = millis();			
		}
	}
	if(mouseX > 650 && mouseX < 770 && mouseY > 220 && mouseY < 262 && mode == 0) {
		pressed = 12;
		resetPositions();
		for(i=0;i<30;i++) command[i] = 0;		
		currentPosition = 0;
		currentCommandPosition = 0;
	}	
	
	
	for(i = 0; i < 7; i++) {
		if(mouseX > 210 && mouseX < 242 && mouseY > 26 + i * 35 && mouseY < 51 + i * 35) {
			pressed = 20 + i;
			if( command[i + currentPosition] != 0) {
				 deleteCommand(i);
			}
		}			
	}
	
		
}


void mouseReleased() {
	pressed = 0;
}